<?php
/*
	Plugin Name: Fast Member
	Plugin URI: http://www.fastmember.com
	Description: Wordpress Membership and Affiliate Management Plugin, including Payment Processing
	Version: 1.0
	Author: Stanil Dobrev, Dave Dunn
	Author URI: http://www.fastmember.com
    Copyright 2011 fastmember.com (email : support@fastmember.com)
*/


# Compatibilty checks
# -----------------------------------------------------

// get wordpress version number and fill it up to 9 digits
$int_wp_version = preg_replace('#[^0-9]#', '', get_bloginfo('version'));
while(strlen($int_wp_version) < 9) $int_wp_version .= '0';

// get php version number and fill it up to 9 digits
$int_php_version = preg_replace('#[^0-9]#', '', phpversion());
while(strlen($int_php_version) < 9) $int_php_version .= '0';

if ($int_wp_version >= 300000000 && 		// Wordpress version > 3.0
	$int_php_version >= 520000000 && 		// PHP version > 5.2
	defined('ABSPATH') && 					// Plugin is not loaded directly
	defined('WPINC')) {						// Plugin is not loaded directly
	define('FASTMEM_DIR', dirname(__FILE__));
	$url = plugins_url('/', __FILE__);
	if (substr($url, -1) != '/') $url .= '/';
	define('FASTMEM_URL', $url);
	define('FASTMEM_PLUGIN_NAME' , 'Fast Member');
	define('FASTMEM_PLUGIN_SLUG' , 'fastmem');
	define('FASTMEM_PLUGIN_VERSION' , '1.0');
	require_once(dirname(__FILE__).'/lib/widgets.php');
	require_once(dirname(__FILE__).'/lib/class.main.php');
	$fastmemplugin = new fastmemPlugin();
	//add_action('init',array('fastmem', 'initialize'));
	//add_action('widgets_init', array('fastmem','create_widget'));
}
else add_action('admin_notices', 'fastmem_incomp');

function fastmem_incomp(){
	echo '<div id="message" class="error">
	<p><b>The &quot;'.$fbl_pluginname.'&quot; Plugin does not work on this WordPress installation!</b></p>
	<p>Please check your WordPress installation for following minimum requirements:</p>
	<p>
	- WordPress version 3.0 or higer<br />
	- PHP version 5.2 or higher<br />
	</p>
	<p>Do you need help? Contact <a href="mailto:support@fastmember.com">Support</a></p>
	</div>';
}

register_activation_hook(__FILE__, 'fastmemInstall');
register_uninstall_hook(__FILE__, 'fastmemUnInstall');

function fastmemInstall() {
	global $wpdb;
    //require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	//dbDelta("
    $wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_products` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`title` VARCHAR( 50 ) NOT NULL ,
			`description` TEXT NOT NULL ,
			`isrecurr` TINYINT(1) UNSIGNED NOT NULL ,
			`trialperiod` ENUM( 'd', 'w', 'm', 'y' ) NOT NULL ,
			`trialquantity` TINYINT UNSIGNED NOT NULL ,
			`trialprice` DECIMAL( 5, 2 ) UNSIGNED NOT NULL,
			`paidperiod` ENUM( 'd', 'w', 'm', 'y' ) NOT NULL ,
			`paidquantity` TINYINT UNSIGNED NOT NULL ,
			`numpayments` SMALLINT UNSIGNED NOT NULL,
			`startprice` DECIMAL( 6, 2 ) UNSIGNED NOT NULL ,
			`endprice` DECIMAL( 6, 2 ) UNSIGNED NOT NULL ,
			`curprice` DECIMAL( 6, 2 ) UNSIGNED NOT NULL,
			`copiesleft` INT UNSIGNED NOT NULL,
			`starttime` INT UNSIGNED NOT NULL,
			`numsales` SMALLINT UNSIGNED NOT NULL default 0,
			`isdimesale` TINYINT( 1 ) UNSIGNED NOT NULL ,
			`dimestartprice` DECIMAL( 6, 2 ) UNSIGNED NOT NULL ,
			`dimeincrement` DECIMAL( 5, 2 ) UNSIGNED NOT NULL ,
			`dimeincrtype` ENUM( 's', 'i', 'h', 'd', 'w', 'm' ) NOT NULL ,
			`dimeincrquantity` TINYINT UNSIGNED NOT NULL ,
			`affsys` ENUM('no','rap','reg') NOT NULL ,
			`defaultaffcomm` TINYINT UNSIGNED NOT NULL ,
			`affcookie` INT UNSIGNED NOT NULL,
			`acceptedpps` VARCHAR(50) NOT NULL,
			`withdrawpps` VARCHAR( 50 ) NOT NULL,
			`withdrawhold` TINYINT UNSIGNED NOT NULL,
			`withdrawmin` DECIMAL( 6, 2 ) UNSIGNED NOT NULL,
			`timecreated` INT UNSIGNED NOT NULL,
			`sendername` VARCHAR(50) NOT NULL,
			`senderemail` VARCHAR(50) NOT NULL,
			`parthidmsg` TEXT NOT NULL,
			`notif_welcome` TEXT NOT NULL,
			`notif_affsale` TEXT NOT NULL,
			`defsalespage` BIGINT UNSIGNED NOT NULL,
			`homepage` BIGINT UNSIGNED NOT NULL,
			`loginpage` BIGINT UNSIGNED NOT NULL,
			`typage` BIGINT UNSIGNED NOT NULL,
			`arservice` TINYINT UNSIGNED NOT NULL ,
			`awlist` VARCHAR( 50 ) NOT NULL,
			`mailchimp_api` VARCHAR( 50 ) NOT NULL ,
			`mailchimp_list` VARCHAR( 50 ) NOT NULL ,
			`ar_formcode` TEXT NOT NULL
		);");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_transactions` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`prodid` INT UNSIGNED NOT NULL,
		`pp` TINYINT UNSIGNED NOT NULL ,
		`txn_id` VARCHAR( 30 ) NOT NULL ,
		`amount` DECIMAL( 6, 2 ) UNSIGNED NOT NULL ,
		`userid` INT UNSIGNED NOT NULL ,
		`affid` INT UNSIGNED NOT NULL ,
		`affiliateemail` VARCHAR( 50 ) NOT NULL ,
		`affcomm` TINYINT UNSIGNED NOT NULL ,
		`israp` TINYINT(1) UNSIGNED NOT NULL,
		`isadaptive` TINYINT(1) UNSIGNED NOT NULL,
		`ttransaction` INT UNSIGNED NOT NULL ,
		`payer_email` VARCHAR( 50 ) NOT NULL
		);");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_users` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`userid` INT UNSIGNED NOT NULL ,
		`prodid` INT UNSIGNED NOT NULL ,
		`tpurchased` INT UNSIGNED NOT NULL,
		`expires` INT UNSIGNED NOT NULL ,
		`affid` INT UNSIGNED NOT NULL ,
		`affcomm` TINYINT UNSIGNED NOT NULL,
		`hitid` INT UNSIGNED NOT NULL,
		`ppemail` VARCHAR( 50 ) NOT NULL ,
		`apemail` VARCHAR( 50 ) NOT NULL ,
		`spemail` VARCHAR( 50 ) NOT NULL,
		`hits` INT UNSIGNED NOT NULL ,
		`uhits` INT UNSIGNED NOT NULL ,
		`revenue` DECIMAL( 7, 2 ) UNSIGNED NOT NULL,
		`profit` DECIMAL( 7, 2 ) UNSIGNED NOT NULL ,
		`withdr` DECIMAL( 7, 2 ) UNSIGNED NOT NULL,
		`numsales` INT UNSIGNED NOT NULL,
		`arlisted` TINYINT( 1 ) UNSIGNED NOT NULL,
		`tfirstlogin` INT UNSIGNED NOT NULL
		);");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_content` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`productid` INT UNSIGNED NOT NULL ,
		`postid` BIGINT UNSIGNED NOT NULL ,
		`remfileid` BIGINT UNSIGNED NOT NULL ,
		`dripday` INT UNSIGNED NOT NULL default 1
		);");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_files` (
		  `productid` int(10) unsigned NOT NULL,
		  `fname` varchar(50),
		  `dripday` int(10) unsigned NOT NULL DEFAULT '1'
		);");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_buttons` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`title` VARCHAR( 20 ) NOT NULL ,
		`buttons` TEXT NOT NULL
		);");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_hits` (
		`id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT,
		`userid` INT UNSIGNED NOT NULL,
		`prodid` INT UNSIGNED NOT NULL ,
		`postid` BIGINT UNSIGNED NOT NULL ,
		`affid` INT UNSIGNED NOT NULL ,
		`affcomm` TINYINT UNSIGNED NOT NULL ,
		`track` VARCHAR( 10 ) NOT NULL ,
		`htime` INT UNSIGNED NOT NULL,
		`userip` INT UNSIGNED NOT NULL,
		`rapisaff` TINYINT(1) UNSIGNED NOT NULL,
		`madesale` TINYINT( 1 ) UNSIGNED NOT NULL ,
		`price` DECIMAL( 6, 2 ) UNSIGNED NOT NULL,
		`otoid` INT UNSIGNED NOT NULL ,
		 PRIMARY KEY (`id`),
		 KEY `prodid` (`prodid`),
		 KEY `htime` (`htime`),
		 KEY `affid` (`affid`),
		 KEY `track` (`track`),
		 KEY `userip` (`userip`),
		 KEY `madesale` (`madesale`)
		);");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_withdrawals` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`affid` INT UNSIGNED NOT NULL ,
		`pmethod` TINYINT UNSIGNED NOT NULL ,
		`accinfo` VARCHAR( 50 ) NOT NULL ,
		`amount` DECIMAL( 7, 2 ) NOT NULL ,
		`wtime` INT UNSIGNED NOT NULL ,
		`ptime` INT UNSIGNED NOT NULL
		);");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_settings` (
		`withdrawpps` VARCHAR( 50 ) NOT NULL ,
		`withdrawhold` TINYINT UNSIGNED NOT NULL ,
		`withdrawmin` DECIMAL( 5, 2 ) UNSIGNED NOT NULL,
		`liccode` VARCHAR( 20 ) NOT NULL,
		`deldb` TINYINT( 1 ) UNSIGNED NOT NULL ,
		`defaultland` BIGINT UNSIGNED NOT NULL,
		`currency` VARCHAR( 3 ) NOT NULL default 'USD'
		);
	");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_otoviews` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`otoid` INT UNSIGNED NOT NULL ,
		`userid` INT UNSIGNED NOT NULL ,
		`numviews` SMALLINT UNSIGNED NOT NULL
		);
	");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_remotefiles` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`fhash` VARCHAR( 20 ) NOT NULL ,
		`url` VARCHAR( 255 ) NOT NULL
		);
	");
	$wpdb->query("
		CREATE TABLE  IF NOT EXISTS `{$wpdb->prefix}wpbn_coupons` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`products` TEXT NOT NULL ,
		`disctype` ENUM(  'percent',  'amount' ) NOT NULL ,
		`discamount` DECIMAL( 5, 2 ) UNSIGNED NOT NULL ,
		`exptype` ENUM(  'copies',  'dates', 'noexp' ) NOT NULL ,
		`expnum` INT UNSIGNED NOT NULL ,
		`curnum` INT UNSIGNED NOT NULL ,
		`landpage` BIGINT UNSIGNED NOT NULL ,
		`dependprod` TEXT NOT NULL ,
		`title` VARCHAR( 100 ) NOT NULL ,
		`description` TEXT NOT NULL ,
		`ccode` VARCHAR( 30 ) NOT NULL
		);
	");
	$wpdb->query("
		CREATE TABLE  IF NOT EXISTS `{$wpdb->prefix}wpbn_autoresponders` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`title` VARCHAR( 100 ) NOT NULL ,
		`products` TEXT NOT NULL ,
		`dependprod` TEXT NOT NULL,
		`active` TINYINT( 1 ) UNSIGNED NOT NULL
		);
	");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_armessages` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`arid` INT UNSIGNED NOT NULL,
		`dripday` INT UNSIGNED NOT NULL ,
		`subject` VARCHAR( 255 ) NOT NULL ,
		`message` MEDIUMTEXT NOT NULL
		);
	");
	$wpdb->query("
		CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}wpbn_mailque` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`email` VARCHAR( 200 ) NOT NULL ,
		`subject` VARCHAR( 255 ) NOT NULL ,
		`message` TEXT NOT NULL
		);
	");
	$wpdb->query("
		CREATE TABLE  IF NOT EXISTS `{$wpdb->prefix}wpbn_chunks` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`title` VARCHAR( 100 ) NOT NULL ,
		`content` MEDIUMTEXT NOT NULL
		);
	");

	//updates for new versions
	$flds = fastmemGetFieldNames("{$wpdb->prefix}wpbn_settings");
	if (!in_array('currency', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_settings` ADD `currency` VARCHAR( 3 ) NOT NULL default 'USD';");
	if (!in_array('digir', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_settings` ADD `digir` VARCHAR( 50 ) NOT NULL default '';");
	if (!in_array('cbsecret', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_settings` ADD `cbsecret` VARCHAR( 50 ) NOT NULL default '';");
	if (!in_array('mailer', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_settings` ADD `mailer` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '1';");
	if (!in_array('mailerconfig', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_settings` ADD `mailerconfig` TEXT NOT NULL;");
	if (!in_array('sendername', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_settings` ADD `sendername` VARCHAR( 50 ) NOT NULL default '';");
	if (!in_array('senderemail', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_settings` ADD `senderemail` VARCHAR( 50 ) NOT NULL default '';");

	$flds = fastmemGetFieldNames("{$wpdb->prefix}wpbn_transactions");
	if (!in_array('isadaptive', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_transactions` ADD `isadaptive` TINYINT(1) UNSIGNED NOT NULL;");
	if (!in_array('isrefunded', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_transactions` ADD `isrefunded` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';");
	if (!in_array('wso', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_transactions` ADD `wso` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';");
	if (!in_array('coupon', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_transactions` ADD `coupon` VARCHAR( 30 ) NOT NULL;");

	$flds = fastmemGetFieldNames("{$wpdb->prefix}wpbn_users");
	if (!in_array('tfirstlogin', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_users` ADD `tfirstlogin` INT UNSIGNED NOT NULL;");

	$flds = fastmemGetFieldNames("{$wpdb->prefix}wpbn_products");
	if (!in_array('loginpage', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `loginpage` BIGINT UNSIGNED NOT NULL;");
	if (!in_array('affcookie', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `affcookie` INT UNSIGNED NOT NULL;");
	if (!in_array('typage', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `typage` BIGINT UNSIGNED NOT NULL;");
	if (!in_array('cbid', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `cbid` VARCHAR( 5 ) NOT NULL;");
	if (!in_array('cbvend', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `cbvend` VARCHAR( 10 ) NOT NULL;");
	if (!in_array('notif_affsale_subj', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `notif_affsale_subj` VARCHAR( 200 ) NOT NULL;");
	if (!in_array('notif_welcome_subj', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `notif_welcome_subj` VARCHAR( 200 ) NOT NULL;");
	if (!in_array('nomem', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `nomem` TINYINT UNSIGNED NOT NULL DEFAULT '4';");
	if (!in_array('nomemmsg', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` ADD `nomemmsg` TEXT NOT NULL;");

	$flds = fastmemGetFieldNames("{$wpdb->prefix}wpbn_hits");
	if (!in_array('otoid', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_hits` ADD `otoid` INT UNSIGNED NOT NULL;");

	$flds = fastmemGetFieldNames("{$wpdb->prefix}wpbn_content");
	if (!in_array('remfileid', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_content` ADD `remfileid` BIGINT UNSIGNED NOT NULL;");

	$flds = fastmemGetFieldNames("{$wpdb->prefix}wpbn_hits");
	if (!in_array('coupon', $flds)) $wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_hits ADD `coupon` VARCHAR( 30 ) NOT NULL;");

	$wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` CHANGE `trialperiod` `trialperiod` ENUM( 'd', 'w', 'm', 'y' ) NOT NULL;");
	$wpdb->query("ALTER TABLE `{$wpdb->prefix}wpbn_products` CHANGE `paidperiod` `paidperiod` ENUM( 'd', 'w', 'm', 'y' ) NOT NULL;");

}



function fastmemUnInstall() {
	global $wpdb;
	$deldb = $wpdb->get_var("SELECT deldb FROM {$wpdb->prefix}wpbn_settings;");
	if (!$deldb) return '';
    $wpdb->query("
		DROP TABLE
		`{$wpdb->prefix}wpbn_buttons` ,
		`{$wpdb->prefix}wpbn_content` ,
		`{$wpdb->prefix}wpbn_files` ,
		`{$wpdb->prefix}wpbn_hits` ,
		`{$wpdb->prefix}wpbn_products` ,
		`{$wpdb->prefix}wpbn_settings` ,
		`{$wpdb->prefix}wpbn_transactions` ,
		`{$wpdb->prefix}wpbn_users` ,
		`{$wpdb->prefix}wpbn_withdrawals` ;
	");
}



function fastmemGetFieldNames($table) {
	global $wpdb;
	$arr = array();
	$res = $wpdb->get_results("SHOW FIELDS FROM `{$table}`");
	foreach ($res as $row) $arr[] = $row->Field;
	return $arr;
}


?>